zoukankan      html  css  js  c++  java
  • HDU-4283 You Are the One

    http://acm.hdu.edu.cn/showproblem.php?pid=4283

            You Are the One

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 1575    Accepted Submission(s): 748


    Problem Description
      The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
     

     

    Input
      The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)
      The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
     

     

    Output
      For each test case, output the least summary of unhappiness .
     

     

    Sample Input
    2  
    5
    1 2 3 4 5
    5
    5 4 3 2 2
     

     

    Sample Output
    Case #1: 20
    Case #2: 24
    题意:有一个队列,每个人有一个愤怒值D,如果他是第K个上场,不开心指数就为(K-1)*D,然后上场的顺序是一个栈。
    dp[i][j]表示i到j的最小不开心值。
    在i,j之间的区间,不管其他的人。枚举i,假设i是从第g个上场,则可以分成3个区间,一个区间是g以前上场的+value[i]*(g-1)+g以后上场的。
    下面状态方程是一一对应:
    dp[i][j]=min(dp[i][j],dp[i+1][g]+val[i]*(g-i)+dp[g+1][j]+(sum[j]-sum[g])*(g-i+1));
    特别是在g以k+1个之后出场的,也就是一个子问题dp[g+1][j],对于这个区间的人,由于排在第g+1个之后,
    所以整体愤怒值要加上(sum[j]-sum[g])*(g-i+1));
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    #define inf 1<<27
    using namespace std;
    int dp[105][105];
    int main()
    {
        int i,t,val[105],n,sum[105],j,k,g,r;
        scanf("%d",&t);
         for(r=1;r<=t;r++)
        {
              scanf("%d",&n);
             memset(dp,0,sizeof(dp));
             memset(sum,0,sizeof(sum));
             for(i=1;i<=n;i++)
             {
                 scanf("%d",&val[i]);
                 sum[i]=val[i]+sum[i-1];
             }
             for(i=1;i<=n;i++)
                for(j=i+1;j<=n;j++)
                    dp[i][j]=inf;
    
             for(k=1;k<=n;k++)
             {
                 for(i=1;i<=n-k;i++)
                   {
                         j=i+k;
                      for(g=i;g<=j;g++)
                         dp[i][j]=min(dp[i][j],val[i]*(g-i)+dp[i+1][g]+dp[g+1][j]+(sum[j]-sum[g])*(g-i+1));
                      
                   }
             }
             printf("Case #%d: %d
    ",r,dp[1][n]);
    
         }
        return 0;
    }
     
     
  • 相关阅读:
    Flask第二篇——服务器相关
    Flask第一篇——URL详解
    Appium 定位方法例子(4)
    selenium 上传文件方法补充——SendKeys、win32gui
    Appium+python (3) 异常处理
    Appium+python (3) 元素定位(1)
    "http://127.0.0.1:4723/wd/hub"的解释
    Appium + Python App自动化(2)第一个脚本
    Appium+python(1)简单的介绍环境搭建
    用fiddler设置手机代理
  • 原文地址:https://www.cnblogs.com/cancangood/p/3869819.html
Copyright © 2011-2022 走看看